two is an interesting dbench case, discrepency between 1 and 10 is quite
[xfstests-dev.git] / bench
1 #!/bin/sh
2
3 # Wrapper for automating benchmarking runs.
4 # Usage:   bench passes user group [script]
5
6 # ..where passes is the number of times to run each script; uid/gid
7 # gives credentials to use when running the script; and script is a
8 # simple wrapper around each actual benchmark tool (eg. see run.*),
9 # if this is ommited, all run.* scripts are used in turn.
10
11 # Each run.foo script should report a comma-separated-value list of
12 # benchmark results on stdout or fail with a non-zero exit code;
13 # unless the -i option is supplied in which case it should instead
14 # report a comma-separated-value list of column headers (for report
15 # generation purposes).
16
17 #-----------------------------------------------------------------------
18 # Copyright (c) 2002 Silicon Graphics, Inc.  All Rights Reserved.
19
20 # This program is free software; you can redistribute it and/or modify it
21 # under the terms of version 2 of the GNU General Public License as
22 # published by the Free Software Foundation.
23
24 # This program is distributed in the hope that it would be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
27
28 # Further, this software is distributed without any warranty that it is
29 # free of the rightful claim of any third person regarding infringement
30 # or the like.  Any license provided herein, whether implied or
31 # otherwise, applies only to this software file.  Patent licenses, if
32 # any, provided herein do not apply to combinations of this program with
33 # other software, or any other product whatsoever.
34
35 # You should have received a copy of the GNU General Public License along
36 # with this program; if not, write the Free Software Foundation, Inc., 59
37 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
38
39 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
40 # Mountain View, CA  94043, or:
41
42 # http://www.sgi.com 
43
44 # For further information regarding this notice, see: 
45
46 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
47 #-----------------------------------------------------------------------
48 #
49 # creator
50 owner=nathans@sgi.com
51
52 tmp=/tmp/$$
53 here=`pwd`; export here
54 status=1        # failure is the default!
55
56 # get standard environment, filters and checks
57 . ./common.rc
58 . ./common.filter
59
60 _cleanup()
61 {
62     echo "        *** umount"
63     umount $SCRATCH_DEV >/dev/null 2>&1
64 }
65
66 OUT="bench.out"
67 LOG="bench.log"
68 FULL="bench.full"
69
70 _log()
71 {
72     echo "$*" 1>&2
73     echo "$*" >>$LOG
74     echo "$*" >>$FULL
75     sync
76 }
77
78 _logp()
79 {
80     tee -a $FULL
81 }
82
83 _fail()
84 {
85     _log "$*"
86     status=1
87     exit 1
88 }
89
90 _run_benchmark()
91 {
92     pass=1
93     uid=`id -u $user`
94     gid=`id -g $group`
95     
96     while [ $pass -le $passes -o $passes -lt 0 ]
97     do
98         _log "        *** clean scratch device [$bench starting, pass $pass]"
99         mkfs_xfs -f $SCRATCH_DEV 2>&1 |  _fix_malloc >>$FULL \
100                             || _fail "            !!! mkfs SCRATCH_DEV failed"
101
102         _log "        *** mounting scratch device"
103         mount -t xfs $SCRATCH_DEV $SCRATCH_MNT \
104                             || _fail "            !!! failed to mount"
105         
106         _log "        *** mkdir"
107         mkdir $SCRATCH_MNT/bench \
108                             || _fail "            !!! couldn't mkdir benchdir"
109         chown -R $user.$group $SCRATCH_MNT/bench \
110                             || _fail "            !!! couldn't chown benchdir"
111
112         cd $SCRATCH_MNT/bench
113         seq=`perl -e 'printf "results.%s.%03d\n", '$bench', '$pass`
114         rm -f $seq $tmp.out
115
116         _log "        *** bench [$seq]"
117         $here/src/runas -u $uid -g $gid $here/run.$bench >$tmp.out 2>>$FULL
118         [ $? -eq 0 ]        || _fail "            !!! $bench pass $pass failed"
119
120         cd $here
121         _fix_malloc < $tmp.out > $seq
122
123         _log "        *** unmounting scratch device"
124         umount $SCRATCH_DEV 2>&1 | _logp \
125                             || _fail "            !!! failed to umount"
126
127         _log "        *** post-umount filesystem check"
128         _check_fs $SCRATCH_DEV
129         
130         let "pass = pass + 1"
131     done
132 }
133
134 _merge_results()
135 {
136     echo Results for $bench benchmark >>$OUT
137     headers=`$here/run.$bench -h`
138     echo "[$headers]" >>$OUT
139     echo results.$bench.* | sort -nu | xargs cat >>$OUT
140     echo >>$OUT
141 }
142
143 # real QA test starts here
144
145 if [ $# -lt 3 ]; then
146     echo Usage:  bench passes user group [script]
147     exit 1
148 fi
149
150 passes=$1
151 user=$2
152 group=$3
153
154 benches=`echo run.* | sed -e 's/run\.//g'`
155 [ $# -gt 3 ] && benches=$4
156 [ -z "$benches" -o "$benches" = "*" ] && _fail "no benchmark scripts found"
157
158 trap "_cleanup; exit \$status" 0 1 2 3 15
159
160 _require_scratch
161
162 echo "MKFS_OPTIONS=$MKFS_OPTIONS" >>$OUT
163 echo "MOUNT_OPTIONS=$MOUNT_OPTIONS" >>$OUT
164 echo "" >>$OUT
165
166 rm -f bench.*
167 for bench in $benches
168 do
169     echo "" >$FULL
170     echo "" >$LOG
171     _log "*** benchmark started [passes=$passes, benchmark=$bench]"
172     _log "*** (`date`)"
173     _log "*** MKFS_OPTIONS=$MKFS_OPTIONS"
174     _log "*** MOUNT_OPTIONS=$MOUNT_OPTIONS"
175     _log "        *** unmounting scratch device"
176     umount $SCRATCH_DEV 2>&1 | _fix_malloc >>$FULL
177
178     _run_benchmark | _fix_malloc
179     _merge_results
180
181     _log "*** done $bench"
182 done
183 status=0